package org.refresh.core.intelligence.emf.tests;

import java.util.List;

import junit.framework.TestCase;

import org.eclipse.emf.examples.extlibrary.Book;
import org.eclipse.emf.examples.extlibrary.EXTLibraryFactory;
import org.eclipse.emf.examples.extlibrary.EXTLibraryPackage;
import org.refresh.core.intelligence.emf.OCLConstraint;
import org.refresh.emf.EMFIntelligence;
import org.refresh.groovy.GroovyConstraint;
import org.refresh.groovy.GroovyEvaluator;

/*******************************************************************************
 * Copyright (c) 2007 Jules White. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jules White - initial API and implementation
 ******************************************************************************/
public class GroovyEvaluatorTest extends TestCase {

	public void testSimpleConstraint() {
		EMFIntelligence kb = new EMFIntelligence();
		GroovyEvaluator eval2 = new GroovyEvaluator();
		kb.getConstraintEvaluators().put(GroovyConstraint.TYPE, eval2);

		OCLConstraint con1 = new OCLConstraint("target.title = target.title");
		GroovyConstraint pcon = new GroovyConstraint(
				"target.title != self.title");
		EXTLibraryFactory fact = EXTLibraryPackage.eINSTANCE
				.getEXTLibraryFactory();
		Book f1 = fact.createBook();
		Book f2 = fact.createBook();
		Book f3 = fact.createBook();
		f1.setTitle("foo");
		f2.setTitle("foo2");
		f3.setTitle("foo");

		assertEquals(true, eval2.evaluate(f1, f2, pcon));

		kb.add(f1);
		kb.add(f2);
		kb.add(f3);

		kb.add(f1.eClass(), "different", f1.eClass(), con1);
		kb.add(f1.eClass(), "different", f1.eClass(), pcon);

		// System.out.println("########################");
		// System.out.println(eval2.getKB().snapshot());
		// System.out.println("########################");

		List valid = kb.validTargets(f1, "different");
		assertEquals(1, valid.size());
		assertEquals(f2, valid.get(0));
	}
}
